Option Strict Off
Imports System
Imports NXOpen
Imports NXOpen.Utilities
Imports NXOpen.UF
Imports NXOpen.Features
Imports NXOpen.Annotations
Imports NXOpen.BlockStyler

Module NX85LimitsFits

    Dim s As Session = Session.GetSession()
    Dim ui As UI = UI.GetUI()
    Dim ufs As UFSession = UFSession.GetUFSession()
    Dim workPart As Part = s.Parts.Work

    Sub Main()
        Try
            Dim DimTolerances1 As New DimTolerances
            DimTolerances1.Show()
            DimTolerances1.Dispose()
        Catch ex As NXException
            ' ---- Enter your exception  code here -----
            ui.NXMessageBox.Show("UI Styler", NXMessageBox.DialogType.Error, ex.Message)
        End Try

    End Sub
    Public Class DimTolerances
        'class members
        Private theDlxFileName As String
        Private theDialog As NXOpen.BlockStyler.BlockDialog
        Private group0 As NXOpen.BlockStyler.Group ' Block type: Group
        Private ToleranceType As NXOpen.BlockStyler.Enumeration ' Block type: Enumeration
        Private deviations As NXOpen.BlockStyler.Enumeration ' Block type: Enumeration
        Private tolerances As NXOpen.BlockStyler.Enumeration ' Block type: Enumeration
        Dim obj(-1) As TaggedObject


#Region "Block Styler Dialog Designer generator code"
        '------------------------------------------------------------------------------
        'Constructor for NX Styler class
        '------------------------------------------------------------------------------
        Public Sub New()
            Try
                theDlxFileName = "DimTolerances.dlx"
                theDialog = ui.CreateDialog(theDlxFileName)
                theDialog.AddApplyHandler(AddressOf apply_cb)
                theDialog.AddOkHandler(AddressOf ok_cb)
                theDialog.AddUpdateHandler(AddressOf update_cb)
                theDialog.AddInitializeHandler(AddressOf initialize_cb)
                theDialog.AddDialogShownHandler(AddressOf dialogShown_cb)

            Catch ex As Exception

                '---- Enter your exception handling code here -----
                Throw ex
            End Try
        End Sub
#End Region

        '------------------------------- DIALOG LAUNCHING ---------------------------------
        '
        '    Before invoking this application one needs to open any part/empty part in NX
        '    because of the behavior of the blocks.
        '
        '    Make sure the dlx file is in one of the following locations:
        '        1.) From where NX session is launched
        '        2.) $UGII_USER_DIR/application
        '        3.) For released applications, using UGII_CUSTOM_DIRECTORY_FILE is highly
        '            recommended. This variable is set to a full directory path to a file 
        '            containing a list of root directories for all custom applications.
        '            e.g., UGII_CUSTOM_DIRECTORY_FILE=$UGII_ROOT_DIR\menus\custom_dirs.dat
        '
        '    You can create the dialog using one of the following way:
        '
        '    1. Journal Replay
        '
        '        1) Replay this file through Tool->Journal->Play Menu.
        '
        '    2. USER EXIT
        '
        '        1) Create the Shared Library -- Refer "Block UI Styler programmer's guide"
        '        2) Invoke the Shared Library through File->Execute->NX Open menu.
        '
        '------------------------------------------------------------------------------
        
        '------------------------------------------------------------------------------
        ' This method specifies how a shared image is unloaded from memory
        ' within NX. This method gives you the capability to unload an
        ' internal NX Open application or user  exit from NX. Specify any
        ' one of the three constants as a return value to determine the type
        ' of unload to perform:
        '
        '
        '    Immediately : unload the library as soon as the automation program has completed
        '    Explicitly  : unload the library from the "Unload Shared Image" dialog
        '    AtTermination : unload the library when the NX session terminates
        '
        '
        ' NOTE:  A program which associates NX Open applications with the menubar
        ' MUST NOT use this option since it will UNLOAD your NX Open application image
        ' from the menubar.
        '------------------------------------------------------------------------------
        Public Shared Function GetUnloadOption(ByVal arg As String) As Integer
            'Return CType(Session.LibraryUnloadOption.Explicitly, Integer)
            Return CType(Session.LibraryUnloadOption.Immediately, Integer)
            ' Return CType(Session.LibraryUnloadOption.AtTermination, Integer)
        End Function
        '------------------------------------------------------------------------------
        ' Following method cleanup any housekeeping chores that may be needed.
        ' This method is automatically called by NX.
        '------------------------------------------------------------------------------
        Public Shared Sub UnloadLibrary(ByVal arg As String)
            Try


            Catch ex As Exception

                '---- Enter your exception handling code here -----
                ui.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
            End Try
        End Sub

        '------------------------------------------------------------------------------
        'This method shows the dialog on the screen
        '------------------------------------------------------------------------------
        Public Sub Show()
            Try

                theDialog.Show()

            Catch ex As Exception

                '---- Enter your exception handling code here -----
                ui.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
            End Try
        End Sub

        '------------------------------------------------------------------------------
        'Method Name: Dispose
        '------------------------------------------------------------------------------
        Public Sub Dispose()
            If theDialog IsNot Nothing Then
                theDialog.Dispose()
                theDialog = Nothing
            End If
        End Sub

        '------------------------------------------------------------------------------
        '---------------------Block UI Styler Callback Functions--------------------------
        '------------------------------------------------------------------------------

        '------------------------------------------------------------------------------
        'Callback Name: initialize_cb
        '------------------------------------------------------------------------------
        Public Sub initialize_cb()
            Try
 group0 = CType(theDialog.TopBlock.FindBlock("group0"), NXOpen.BlockStyler.Group)
                ToleranceType = CType(theDialog.TopBlock.FindBlock("ToleranceType"), NXOpen.BlockStyler.Enumeration)
                deviations = CType(theDialog.TopBlock.FindBlock("deviations"), NXOpen.BlockStyler.Enumeration)
                tolerances = CType(theDialog.TopBlock.FindBlock("tolerances"), NXOpen.BlockStyler.Enumeration)
            Catch ex As Exception

                '---- Enter your exception handling code here -----
                ui.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
            End Try
        End Sub

        '------------------------------------------------------------------------------
        'Callback Name: dialogShown_cb
        'This callback is executed just before the dialog launch. Thus any value set 
        'here will take precedence and dialog will be launched showing that value. 
        '------------------------------------------------------------------------------
        Public Sub dialogShown_cb()
            Dim deviationsprops As PropertyList = deviations.GetProperties
            Dim tolerancesprops As PropertyList = tolerances.GetProperties
            Dim tolerancetypeprops As PropertyList = ToleranceType.GetProperties
            Dim tolerancetypeint As Integer = tolerancetypeprops.GetEnum("Value")
            Try
                If tolerancetypeint = 0 Then
                    deviationsprops.SetLogical("Show", True)
                    tolerancesprops.SetLogical("Show", False)
                Else
                    deviationsprops.SetLogical("Show", False)
                    tolerancesprops.SetLogical("Show", True)
                End If
            Catch ex As Exception
                '---- Enter your exception handling code here -----
                ui.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
            End Try
        End Sub

        '------------------------------------------------------------------------------
        'Callback Name: apply_cb
        '------------------------------------------------------------------------------
        Public Function apply_cb() As Integer
            Dim errorCode As Integer = 0
            Dim response1 As Selection.Response = Selection.Response.Cancel
            Dim deviationsprops As PropertyList = deviations.GetProperties
            Dim tolerancesprops As PropertyList = tolerances.GetProperties
            Dim tolerancetypeprops As PropertyList = ToleranceType.GetProperties
            Dim tolerancetypeint As Integer = tolerancetypeprops.GetEnum("Value")
            Dim limitsfitint As Integer = deviationsprops.GetEnum("Value")
            Dim toleranceint As Integer = tolerancesprops.GetEnum("Value")
            Dim deviation As String = Nothing
            Dim limitfitgrade As Integer = Nothing
            Dim lowertolerancevalue As Double = Nothing
            Dim uppertolerancevalue As Double = Nothing
            Try
                response1 = Select_dims(obj)
                If tolerancetypeint = 0 Then ' limits and fits

                    Select Case limitsfitint
                        Case 0 ' f8
                            deviation = "f"
                            limitfitgrade = 8
                            EditDimensionLimitFit(obj, deviation, limitfitgrade)
                        Case 1 ' g6
                            deviation = "g"
                            limitfitgrade = 6
                            EditDimensionLimitFit(obj, deviation, limitfitgrade)
                        Case 2 ' k6
                            deviation = "k"
                            limitfitgrade = 6
                            EditDimensionLimitFit(obj, deviation, limitfitgrade)
                        Case 3 ' m6
                            deviation = "m"
                            limitfitgrade = 6
                            EditDimensionLimitFit(obj, deviation, limitfitgrade)
                        Case 4 ' p6
                            deviation = "p"
                            limitfitgrade = 6
                            EditDimensionLimitFit(obj, deviation, limitfitgrade)
                        Case 5 ' H7
                            deviation = "H"
                            limitfitgrade = 7
                            EditDimensionLimitFit(obj, deviation, limitfitgrade)
                        Case Else
                    End Select
                Else ' tolerances
                    Select Case toleranceint
                        Case 0
                            uppertolerancevalue = 0.01
                            lowertolerancevalue = -0.01
                            EditDimensionTolerances(obj, uppertolerancevalue, lowertolerancevalue)
                        Case 1
                            uppertolerancevalue = 0.02
                            lowertolerancevalue = -0.02
                            EditDimensionTolerances(obj, uppertolerancevalue, lowertolerancevalue)
                        Case 2
                            uppertolerancevalue = 0.05
                            lowertolerancevalue = -0.05
                            EditDimensionTolerances(obj, uppertolerancevalue, lowertolerancevalue)
                        Case 3
                            uppertolerancevalue = 0.1
                            lowertolerancevalue = -0.1
                            EditDimensionTolerances(obj, uppertolerancevalue, lowertolerancevalue)
                        Case 4
                            uppertolerancevalue = 0.2
                            lowertolerancevalue = -0.2
                            EditDimensionTolerances(obj, uppertolerancevalue, lowertolerancevalue)
                        Case 5
                            uppertolerancevalue = 0.5
                            lowertolerancevalue = -0.5
                            EditDimensionTolerances(obj, uppertolerancevalue, lowertolerancevalue)
                        Case 6
                            uppertolerancevalue = 0.01
                            lowertolerancevalue = 0
                            EditDimensionTolerances(obj, uppertolerancevalue, lowertolerancevalue)
                        Case 7
                            uppertolerancevalue = 0.02
                            lowertolerancevalue = 0
                            EditDimensionTolerances(obj, uppertolerancevalue, lowertolerancevalue)
                        Case 8
                            uppertolerancevalue = 0.05
                            lowertolerancevalue = 0
                            EditDimensionTolerances(obj, uppertolerancevalue, lowertolerancevalue)
                        Case 9
                            uppertolerancevalue = 0.1
                            lowertolerancevalue = 0
                            EditDimensionTolerances(obj, uppertolerancevalue, lowertolerancevalue)
                        Case 10
                            uppertolerancevalue = 0.2
                            lowertolerancevalue = 0
                            EditDimensionTolerances(obj, uppertolerancevalue, lowertolerancevalue)
                        Case 11
                            uppertolerancevalue = 0.5
                            lowertolerancevalue = 0
                            EditDimensionTolerances(obj, uppertolerancevalue, lowertolerancevalue)
                        Case 12
                            uppertolerancevalue = 0
                            lowertolerancevalue = -0.01
                            EditDimensionTolerances(obj, uppertolerancevalue, lowertolerancevalue)
                        Case 13
                            uppertolerancevalue = 0
                            lowertolerancevalue = -0.02
                            EditDimensionTolerances(obj, uppertolerancevalue, lowertolerancevalue)
                        Case 14
                            uppertolerancevalue = 0
                            lowertolerancevalue = -0.05
                            EditDimensionTolerances(obj, uppertolerancevalue, lowertolerancevalue)
                        Case 15
                            uppertolerancevalue = 0
                            lowertolerancevalue = -0.1
                            EditDimensionTolerances(obj, uppertolerancevalue, lowertolerancevalue)
                        Case 16
                            uppertolerancevalue = 0
                            lowertolerancevalue = -0.2
                            EditDimensionTolerances(obj, uppertolerancevalue, lowertolerancevalue)
                        Case 17
                            uppertolerancevalue = 0
                            lowertolerancevalue = -0.5
                            EditDimensionTolerances(obj, uppertolerancevalue, lowertolerancevalue)
                        Case Else
                    End Select
                End If
            Catch ex As Exception
                '---- Enter your exception handling code here -----
                errorCode = 1
                ui.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
            End Try
            apply_cb = errorCode
        End Function

        '------------------------------------------------------------------------------
        'Callback Name: update_cb
        '------------------------------------------------------------------------------
        Public Function update_cb(ByVal block As NXOpen.BlockStyler.UIBlock) As Integer
            Dim deviationsprops As PropertyList = deviations.GetProperties
            Dim tolerancesprops As PropertyList = tolerances.GetProperties
            Dim tolerancetypeprops As PropertyList = ToleranceType.GetProperties
            Dim tolerancetypeint As Integer = tolerancetypeprops.GetEnum("Value")
            Try
                If block Is ToleranceType Then
                    If tolerancetypeint = 0 Then
                        deviationsprops.SetLogical("Show", True)
                        tolerancesprops.SetLogical("Show", False)
                    Else
                        deviationsprops.SetLogical("Show", False)
                        tolerancesprops.SetLogical("Show", True)
                    End If
                End If
            Catch ex As Exception
                '---- Enter your exception handling code here -----
                ui.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
            End Try
            update_cb = 0
        End Function

        '------------------------------------------------------------------------------
        'Callback Name: ok_cb
        '------------------------------------------------------------------------------
        Public Function ok_cb() As Integer
            Dim errorCode As Integer = 0
            Try
                errorCode = apply_cb()
            Catch ex As Exception
                '---- Enter your exception handling code here -----
                errorCode = 1
                ui.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
            End Try
            ok_cb = errorCode
        End Function

        '------------------------------------------------------------------------------
        'Function Name: GetBlockProperties
        'Returns the propertylist of the specified BlockID
        '------------------------------------------------------------------------------
        Public Function GetBlockProperties(ByVal blockID As String) As PropertyList
            GetBlockProperties = Nothing
            Try
                GetBlockProperties = theDialog.GetBlockProperties(blockID)
            Catch ex As Exception
                '---- Enter your exception handling code here -----
                ui.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
            End Try
        End Function
        ' ----------------------------------------------
        '   function to select dimensions
        ' ----------------------------------------------
        Function Select_dims(ByRef obj() As TaggedObject) As Selection.Response
            Dim resp As Selection.Response = Selection.Response.Cancel
            Dim prompt As String = "Select dimensions"
            Dim message As String = "Select dimensions"
            Dim title As String = "Selection"
            Dim scope As Selection.SelectionScope = Selection.SelectionScope.WorkPart
            Dim selAction As Selection.SelectionAction = Selection.SelectionAction.ClearAndEnableSpecific
            Dim selectionMask_array(0) As Selection.MaskTriple
            Dim includeFeatures As Boolean = False
            Dim keepHighlighted As Boolean = False
            With selectionMask_array(0)
                .Type = UFConstants.UF_dimension_type
                .Subtype = 0
                .SolidBodySubtype = 0
            End With
            resp = ui.SelectionManager.SelectTaggedObjects(prompt, message, _
                scope, selAction, includeFeatures, keepHighlighted, selectionMask_array, obj)
            If resp = Selection.Response.ObjectSelected Or _
               resp = Selection.Response.ObjectSelectedByName Then
                Return Selection.Response.Ok
            Else
                Return Selection.Response.Cancel
            End If
        End Function
        Sub EditDimensionLimitFit(ByVal selecteddims() As TaggedObject, ByVal deviation As String, ByVal limitfitgrade As Integer)
            '------------------------------------------------------------------------------
            Dim markId3 As Session.UndoMarkId
            Dim dimname1 As String = Nothing
            For Each selecteddim As Dimension In selecteddims
                dimname1 = selecteddim.ToString()
                If dimname1.Contains("Radius") = True Then
                    Dim radiusDimension1 As Annotations.RadiusDimension = selecteddim
                    Dim linearTolerance1 As Annotations.LinearTolerance
                    linearTolerance1 = radiusDimension1.GetTolerance()
                    linearTolerance1.ToleranceType = Annotations.ToleranceType.LimitsAndFits
                    radiusDimension1.SetTolerance(linearTolerance1)
                    Dim dimensionPreferences1 As Annotations.DimensionPreferences
                    dimensionPreferences1 = radiusDimension1.GetDimensionPreferences()
                    dimensionPreferences1.LimitFitDeviation = deviation
                    dimensionPreferences1.LimitFitGrade = limitfitgrade
                    radiusDimension1.SetDimensionPreferences(dimensionPreferences1)
                ElseIf dimname1.Contains("Horizontal") = True Then
                    Dim horizontalDimension1 As Annotations.HorizontalDimension = selecteddim
                    Dim linearTolerance1 As Annotations.LinearTolerance
                    linearTolerance1 = horizontalDimension1.GetTolerance()
                    linearTolerance1.ToleranceType = Annotations.ToleranceType.LimitsAndFits
                    horizontalDimension1.SetTolerance(linearTolerance1)
                    Dim dimensionPreferences1 As Annotations.DimensionPreferences
                    dimensionPreferences1 = horizontalDimension1.GetDimensionPreferences()
                    dimensionPreferences1.LimitFitDeviation = deviation
                    dimensionPreferences1.LimitFitGrade = limitfitgrade
                    horizontalDimension1.SetDimensionPreferences(dimensionPreferences1)
                ElseIf dimname1.Contains("Vertical") = True Then
                    Dim verticalDimension1 As Annotations.VerticalDimension = selecteddim
                    Dim linearTolerance1 As Annotations.LinearTolerance
                    linearTolerance1 = verticalDimension1.GetTolerance()
                    linearTolerance1.ToleranceType = Annotations.ToleranceType.LimitsAndFits
                    verticalDimension1.SetTolerance(linearTolerance1)
                    Dim dimensionPreferences1 As Annotations.DimensionPreferences
                    dimensionPreferences1 = verticalDimension1.GetDimensionPreferences()
                    dimensionPreferences1.LimitFitDeviation = deviation
                    dimensionPreferences1.LimitFitGrade = limitfitgrade
                    verticalDimension1.SetDimensionPreferences(dimensionPreferences1)
                ElseIf dimname1.Contains("Parallel") = True Then
                    Dim ParallelDimension1 As Annotations.ParallelDimension = selecteddim
                    Dim linearTolerance1 As Annotations.LinearTolerance
                    linearTolerance1 = ParallelDimension1.GetTolerance()
                    linearTolerance1.ToleranceType = Annotations.ToleranceType.LimitsAndFits
                    ParallelDimension1.SetTolerance(linearTolerance1)
                    Dim dimensionPreferences1 As Annotations.DimensionPreferences
                    dimensionPreferences1 = ParallelDimension1.GetDimensionPreferences()
                    dimensionPreferences1.LimitFitDeviation = deviation
                    dimensionPreferences1.LimitFitGrade = limitfitgrade
                    ParallelDimension1.SetDimensionPreferences(dimensionPreferences1)
                ElseIf dimname1.Contains("Diameter") = True Then
                    Dim DiameterDimension1 As Annotations.DiameterDimension = selecteddim
                    Dim linearTolerance1 As Annotations.LinearTolerance
                    linearTolerance1 = DiameterDimension1.GetTolerance()
                    linearTolerance1.ToleranceType = Annotations.ToleranceType.LimitsAndFits
                    DiameterDimension1.SetTolerance(linearTolerance1)
                    Dim dimensionPreferences1 As Annotations.DimensionPreferences
                    dimensionPreferences1 = DiameterDimension1.GetDimensionPreferences()
                    dimensionPreferences1.LimitFitDeviation = deviation
                    dimensionPreferences1.LimitFitGrade = limitfitgrade
                    DiameterDimension1.SetDimensionPreferences(dimensionPreferences1)
                ElseIf dimname1.Contains("Cylindrical") = True Then
                    Dim CylindricalDimension1 As Annotations.CylindricalDimension = selecteddim
                    Dim linearTolerance1 As Annotations.LinearTolerance
                    linearTolerance1 = CylindricalDimension1.GetTolerance()
                    linearTolerance1.ToleranceType = Annotations.ToleranceType.LimitsAndFits
                    CylindricalDimension1.SetTolerance(linearTolerance1)
                    Dim dimensionPreferences1 As Annotations.DimensionPreferences
                    dimensionPreferences1 = CylindricalDimension1.GetDimensionPreferences()
                    dimensionPreferences1.LimitFitDeviation = deviation
                    dimensionPreferences1.LimitFitGrade = limitfitgrade
                    CylindricalDimension1.SetDimensionPreferences(dimensionPreferences1)
                ElseIf dimname1.Contains("Perpendicular") = True Then
                    Dim PerpendicularDimension1 As Annotations.PerpendicularDimension = selecteddim
                    Dim linearTolerance1 As Annotations.LinearTolerance
                    linearTolerance1 = PerpendicularDimension1.GetTolerance()
                    linearTolerance1.ToleranceType = Annotations.ToleranceType.LimitsAndFits
                    PerpendicularDimension1.SetTolerance(linearTolerance1)
                    Dim dimensionPreferences1 As Annotations.DimensionPreferences
                    dimensionPreferences1 = PerpendicularDimension1.GetDimensionPreferences()
                    dimensionPreferences1.LimitFitDeviation = deviation
                    dimensionPreferences1.LimitFitGrade = limitfitgrade
                    PerpendicularDimension1.SetDimensionPreferences(dimensionPreferences1)
                End If
            Next
            Dim nErrs1 As Integer
            nErrs1 = s.UpdateManager.DoUpdate(markId3)
        End Sub

        '------------------------------------------------------------------------
        Sub EditDimensionTolerances(ByVal selecteddims() As TaggedObject, ByVal uppertolerancevalue As Double, _
                                    ByVal lowertolerancevalue As Double)
            '-------------------------------------------------------------------------
            Dim markId3 As Session.UndoMarkId
            Dim dimname1 As String = Nothing
            For Each selecteddim As Dimension In selecteddims
                dimname1 = selecteddim.ToString()
                If dimname1.Contains("Radius") = True Then
                    Dim radiusDimension1 As Annotations.RadiusDimension = selecteddim
                    Dim linearTolerance1 As Annotations.LinearTolerance
                    linearTolerance1 = radiusDimension1.GetTolerance()
                    Dim upperToleranceMm1 As Annotations.Value = Nothing
                    Dim lowerToleranceMm1 As Annotations.Value = Nothing
                    If lowertolerancevalue = 0 And uppertolerancevalue <> 0 Then ' + tolerance
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.UnilateralAbove
                        upperToleranceMm1.ItemValue = uppertolerancevalue
                        upperToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetUpperToleranceMm(upperToleranceMm1)
                    ElseIf lowertolerancevalue <> 0 And uppertolerancevalue = 0 Then ' - tolerance
                        lowerToleranceMm1.ItemValue = lowertolerancevalue
                        lowerToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetLowerToleranceMm(lowerToleranceMm1)
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.UnilateralBelow
                    ElseIf lowertolerancevalue <> 0 And uppertolerancevalue <> 0 Then ' +/- tolerance
                        upperToleranceMm1.ItemValue = uppertolerancevalue
                        upperToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetUpperToleranceMm(upperToleranceMm1)
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.BilateralOneLine
                    End If
                    radiusDimension1.SetTolerance(linearTolerance1)
                ElseIf dimname1.Contains("Horizontal") = True Then
                    Dim horizontalDimension1 As Annotations.HorizontalDimension = selecteddim
                    Dim linearTolerance1 As Annotations.LinearTolerance
                    linearTolerance1 = horizontalDimension1.GetTolerance()
                    Dim upperToleranceMm1 As Annotations.Value = Nothing
                    Dim lowerToleranceMm1 As Annotations.Value = Nothing
                    If lowertolerancevalue = 0 And uppertolerancevalue <> 0 Then ' + tolerance
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.UnilateralAbove
                        upperToleranceMm1.ItemValue = uppertolerancevalue
                        upperToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetUpperToleranceMm(upperToleranceMm1)
                    ElseIf lowertolerancevalue <> 0 And uppertolerancevalue = 0 Then ' - tolerance
                        lowerToleranceMm1.ItemValue = lowertolerancevalue
                        lowerToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetLowerToleranceMm(lowerToleranceMm1)
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.UnilateralBelow
                    ElseIf lowertolerancevalue <> 0 And uppertolerancevalue <> 0 Then ' +/- tolerance
                        upperToleranceMm1.ItemValue = uppertolerancevalue
                        upperToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetUpperToleranceMm(upperToleranceMm1)
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.BilateralOneLine
                    End If
                    horizontalDimension1.SetTolerance(linearTolerance1)
                ElseIf dimname1.Contains("Vertical") = True Then
                    Dim verticalDimension1 As Annotations.VerticalDimension = selecteddim
                    Dim linearTolerance1 As Annotations.LinearTolerance
                    linearTolerance1 = verticalDimension1.GetTolerance()
                    Dim upperToleranceMm1 As Annotations.Value = Nothing
                    Dim lowerToleranceMm1 As Annotations.Value = Nothing
                    If lowertolerancevalue = 0 And uppertolerancevalue <> 0 Then ' + tolerance
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.UnilateralAbove
                        upperToleranceMm1.ItemValue = uppertolerancevalue
                        upperToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetUpperToleranceMm(upperToleranceMm1)
                    ElseIf lowertolerancevalue <> 0 And uppertolerancevalue = 0 Then ' - tolerance
                        lowerToleranceMm1.ItemValue = lowertolerancevalue
                        lowerToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetLowerToleranceMm(lowerToleranceMm1)
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.UnilateralBelow
                    ElseIf lowertolerancevalue <> 0 And uppertolerancevalue <> 0 Then ' +/- tolerance
                        upperToleranceMm1.ItemValue = uppertolerancevalue
                        upperToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetUpperToleranceMm(upperToleranceMm1)
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.BilateralOneLine
                    End If
                    verticalDimension1.SetTolerance(linearTolerance1)
                ElseIf dimname1.Contains("Parallel") = True Then
                    Dim ParallelDimension1 As Annotations.ParallelDimension = selecteddim
                    Dim linearTolerance1 As Annotations.LinearTolerance
                    linearTolerance1 = ParallelDimension1.GetTolerance()
                    linearTolerance1.ToleranceType = Annotations.ToleranceType.None
                    linearTolerance1.ToleranceType = Annotations.ToleranceType.BilateralOneLine
                    Dim upperToleranceMm1 As Annotations.Value = Nothing
                    Dim lowerToleranceMm1 As Annotations.Value = Nothing
                    If lowertolerancevalue = 0 And uppertolerancevalue <> 0 Then ' + tolerance
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.UnilateralAbove
                        upperToleranceMm1.ItemValue = uppertolerancevalue
                        upperToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetUpperToleranceMm(upperToleranceMm1)
                    ElseIf lowertolerancevalue <> 0 And uppertolerancevalue = 0 Then ' - tolerance
                        lowerToleranceMm1.ItemValue = lowertolerancevalue
                        lowerToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetLowerToleranceMm(lowerToleranceMm1)
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.UnilateralBelow
                    ElseIf lowertolerancevalue <> 0 And uppertolerancevalue <> 0 Then ' +/- tolerance
                        upperToleranceMm1.ItemValue = uppertolerancevalue
                        upperToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetUpperToleranceMm(upperToleranceMm1)
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.BilateralOneLine
                    End If
                    ParallelDimension1.SetTolerance(linearTolerance1)
                ElseIf dimname1.Contains("Diameter") = True Then
                    Dim DiameterDimension1 As Annotations.DiameterDimension = selecteddim
                    Dim linearTolerance1 As Annotations.LinearTolerance
                    linearTolerance1 = DiameterDimension1.GetTolerance()
                    linearTolerance1.ToleranceType = Annotations.ToleranceType.None
                    linearTolerance1.ToleranceType = Annotations.ToleranceType.BilateralOneLine
                    Dim upperToleranceMm1 As Annotations.Value = Nothing
                    Dim lowerToleranceMm1 As Annotations.Value = Nothing
                    If lowertolerancevalue = 0 And uppertolerancevalue <> 0 Then ' + tolerance
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.UnilateralAbove
                        upperToleranceMm1.ItemValue = uppertolerancevalue
                        upperToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetUpperToleranceMm(upperToleranceMm1)
                    ElseIf lowertolerancevalue <> 0 And uppertolerancevalue = 0 Then ' - tolerance
                        lowerToleranceMm1.ItemValue = lowertolerancevalue
                        lowerToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetLowerToleranceMm(lowerToleranceMm1)
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.UnilateralBelow
                    ElseIf lowertolerancevalue <> 0 And uppertolerancevalue <> 0 Then ' +/- tolerance
                        upperToleranceMm1.ItemValue = uppertolerancevalue
                        upperToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetUpperToleranceMm(upperToleranceMm1)
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.BilateralOneLine
                    End If
                    DiameterDimension1.SetTolerance(linearTolerance1)
                ElseIf dimname1.Contains("Cylindrical") = True Then
                    Dim CylindricalDimension1 As Annotations.CylindricalDimension = selecteddim
                    Dim linearTolerance1 As Annotations.LinearTolerance
                    linearTolerance1 = CylindricalDimension1.GetTolerance()
                    linearTolerance1.ToleranceType = Annotations.ToleranceType.None
                    linearTolerance1.ToleranceType = Annotations.ToleranceType.BilateralOneLine
                    Dim upperToleranceMm1 As Annotations.Value = Nothing
                    Dim lowerToleranceMm1 As Annotations.Value = Nothing
                    If lowertolerancevalue = 0 And uppertolerancevalue <> 0 Then ' + tolerance
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.UnilateralAbove
                        upperToleranceMm1.ItemValue = uppertolerancevalue
                        upperToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetUpperToleranceMm(upperToleranceMm1)
                    ElseIf lowertolerancevalue <> 0 And uppertolerancevalue = 0 Then ' - tolerance
                        lowerToleranceMm1.ItemValue = lowertolerancevalue
                        lowerToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetLowerToleranceMm(lowerToleranceMm1)
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.UnilateralBelow
                    ElseIf lowertolerancevalue <> 0 And uppertolerancevalue <> 0 Then ' +/- tolerance
                        upperToleranceMm1.ItemValue = uppertolerancevalue
                        upperToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetUpperToleranceMm(upperToleranceMm1)
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.BilateralOneLine
                    End If
                    CylindricalDimension1.SetTolerance(linearTolerance1)
                ElseIf dimname1.Contains("Perpendicular") = True Then
                    Dim PerpendicularDimension1 As Annotations.PerpendicularDimension = selecteddim
                    Dim linearTolerance1 As Annotations.LinearTolerance
                    linearTolerance1 = PerpendicularDimension1.GetTolerance()
                    linearTolerance1.ToleranceType = Annotations.ToleranceType.None
                    linearTolerance1.ToleranceType = Annotations.ToleranceType.BilateralOneLine
                    Dim upperToleranceMm1 As Annotations.Value = Nothing
                    Dim lowerToleranceMm1 As Annotations.Value = Nothing
                    If lowertolerancevalue = 0 And uppertolerancevalue <> 0 Then ' + tolerance
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.UnilateralAbove
                        upperToleranceMm1.ItemValue = uppertolerancevalue
                        upperToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetUpperToleranceMm(upperToleranceMm1)
                    ElseIf lowertolerancevalue <> 0 And uppertolerancevalue = 0 Then ' - tolerance
                        lowerToleranceMm1.ItemValue = lowertolerancevalue
                        lowerToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetLowerToleranceMm(lowerToleranceMm1)
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.UnilateralBelow
                    ElseIf lowertolerancevalue <> 0 And uppertolerancevalue <> 0 Then ' +/- tolerance
                        upperToleranceMm1.ItemValue = uppertolerancevalue
                        upperToleranceMm1.ValuePrecision = 2
                        linearTolerance1.SetUpperToleranceMm(upperToleranceMm1)
                        linearTolerance1.ToleranceType = Annotations.ToleranceType.BilateralOneLine
                    End If
                    PerpendicularDimension1.SetTolerance(linearTolerance1)
                End If
            Next
            Dim nErrs1 As Integer
            nErrs1 = s.UpdateManager.DoUpdate(markId3)

        End Sub
    End Class
End Module
